#ifndef BITSOCK_H
#define BITSOCK_H

class Frame;

class BitSocket : public GameObject
{
public:
	BitSocket(Vector const& pos, Frame* parent, int flags);

	virtual void Update();
	virtual void Move();

	virtual void SetGroupID(Uint32);

	virtual bool IsDisabled() const;
	virtual bool IsSpecial() const;
	virtual bool IsEmpty() const;

	virtual void FireBit();

	virtual void CreateBit();
	virtual void DeleteBit();
	virtual void EmancipateBit();

	virtual void IsInside(GameObject*,Vector const& uRel, Vector const& dif) {}
	virtual void AddForceTo(GameObject*const g);
	virtual void AddForce(Vector const& f) {}

	Vector const& GetOffset();

	virtual void RotateAbout(Vector const&,float a);
private:
	Vector F_Sock(float d,Vector const& v, Vector const& dir);
	Vector F_Fire(Vector const& dir);

	Frame* _parentFrame;
	Bit* _bit;

	bool _empty;
	bool _special;
	bool _disabled;

	Vector _offset;

	float _sockRad;
};
#endif
