#ifndef ENEMY_H
#define ENEMY_H

enum MoveDir
{
	DIR_LEFT,
	DIR_RIGHT,
	DIR_UP,
	DIR_DOWN
};

class Enemy : public GameObject
{
public:
	Enemy(Vector const&, Colour const&, Uint32 releaseTime);

	virtual void Update();
	void Release();
	void Die();
	virtual void IsInside(GameObject *g);
private:
	virtual void Move();
	void RandDir();

	bool _free;
	bool _dead;
	const Vector _startPos;
	Timer _releaseTimer;
	Uint32 _releaseTime;
	Timer _deadTimer;

	MoveDir _dir;
	static const Vector _releasePos;
	static const Uint32 _deadTime;
};
#endif
