#ifndef FRAME_H
#define FRAME_H

using namespace std;

class Frame : public GameObject
{
public:
	Frame(Vector const& pos, FrameType f);
	virtual ~Frame();

	virtual void Update();
	virtual void Stop();

	virtual void SetGroupID(Uint32);

	virtual void IsInside(GameObject*,Vector const& uRel, Vector const& dif);

	bool AddFuelBit();
	bool RemoveFuelBit();

	virtual void FireFuel();
	virtual void RotateAbout(Vector const&,float a);
protected:
	void LoadFromTemplate(FrameTemplate const*const);
	virtual void Move();
	virtual void UpdateSockets();
	virtual void DestroySockets();

	//void LoadFromFile(string file);

	int _sockW, _sockH;
	FrameType _fType;

	//Vector _socketOffset;
	//static char _charSockArray[30][30];
	BitSocket* _socketArray[30][30];
};
#endif
