#ifndef FRAMES_H
#define FRAMES_H

enum FrameType
{
	FRAME_ACE,
	FRAME_APERTURE,
	FRAME_CAPSULE,
	FRAME_DISCUS,
	FRAME_EXCALIBUR,
	FRAME_KERNEL,
	FRAME_MONARCH,
	FRAME_NEEDLE,
	FRAME_ROGUE,
	FRAME_SEPTER,
	FRAME_STING,
	FRAME_THERMIDOR,
	FRAME_TRIDENT,
	FRAME_WRAITH,
	FRAME_MAX
};

struct FrameTemplate
{
	Texture const* t;
	std::string name;
	int mass;
	int sockW, sockH;
	char socketTemplate[30][30];
	Vector socketOffset;

	FrameTemplate()
	{
		t = NULL;
		name = "";
		mass = 20;
		sockW = sockH = 0;

		for(int i = 0; i < 30; i++)
		{
			for(int j = 0; j < 30; j++)
			{
				socketTemplate[i][j] = 'J';
			}
		}
	}
};

class FrameStore
{
public:
	static bool Initialize();
	static FrameTemplate const* GetTemplate(FrameType);
	static void Free();
private:
	static bool LoadTemplate(int);
	static FrameTemplate* LoadFromFile(char const* file);
	static bool ValidBS(char);

	static std::map<FrameType,FrameTemplate const*> _templates;
	static bool _initialized;

	FrameStore();
	FrameStore(const FrameStore&);
};
#endif
