#ifndef GAME_H
#define GAME_H

class Game
{
public:
	static void Initialize();
	static void Run();
	static void Close();

	static void AddObject(Entity*);
	static void AddGameObject(GameObject*);
	static void Remove(Entity*);
	static void Restart();
	static float GetFPS();
	Game();
private:
	static void DoRestart();
	static bool _run;

	static GameState* _state;
	static Timer _gameTimer;
	static Uint32 _lastTick;

	static float _fps;


	static bool _restart;

	static Window *_window;
	static Render *_render;

	static Keyboard *_keyboard;
};
#endif
