#include <iostream>
#include <vector>
#include <map>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include "Transform.h"
#include "Texture.h"
#include "Vector.h"
#include "Rectangle.h"
#include "Colour.h"
#include "Window.h"
#include "Graphics.h"
#include "Entity.h"

#include "GameObject.h"

Uint32 GameObject::_nObjects = 0;

GameObject::GameObject(Vector const& pos):Entity(pos)
{
	_vel = Vector();
	_gID = ++_nObjects;
	_collides = false;
}

void GameObject::SetVel(Vector const& vel) { _vel = vel; }
void GameObject::SetGroupID(Uint32 id) { _gID = id; }

Vector const& GameObject::GetVel() const { return _vel; }
Uint32 GameObject::GetGroupID() const { return _gID; }

bool GameObject::Collides() const { return _collides; }

float GameObject::GetDistanceTo(Vector const& p) const
{
	Vector dif = GetCentre() - p;
	
	return dif.Magnitude();
}

Vector GameObject::GetDirectionTo(Vector const& p) const
{
	Vector dif = GetCentre() - p;

	return dif.Versor();
}
