#ifndef GAMEOBJ_H
#define GAMEOBJ_H

class GameObject : public Entity
{
public:
	GameObject(Vector const& pos);
	virtual ~GameObject(){}

	virtual float GetDistanceTo(Vector const&) const;
	virtual Vector GetDirectionTo(Vector const&) const;

	Uint32 GetGroupID() const;
	virtual Vector const& GetVel() const;

	bool Collides() const;

	virtual void SetVel(Vector const&);
	virtual void SetGroupID(Uint32);

	virtual void IsInside(GameObject*) {}

	virtual void Die() {}

	virtual void Update() = 0;

	static Uint32 Count();
protected:
	virtual void Move() = 0;

	Vector _vel;

	bool _collides;

	Uint32 _gID;
	static Uint32 _nObjects;
};
#endif
