#ifndef GAMESTATE_H
#define GAMESTATE_H

#define STATE_MAIN 0

class GameState
{
public:
	void AddObject(Entity *const obj);
	void AddGameObject(GameObject *const obj);
	void RemoveObjectLater(Entity *const obj);

	virtual void Update();

	virtual void HandleEvents() = 0;
	virtual bool Initialize() = 0;

	GameState(Keyboard const*const, Render *const,Window *const);
	virtual ~GameState();
protected:
	virtual void RemoveDeleted();
	virtual void UpdateObjects();
	virtual void DrawObjects();
	virtual void DestroyObjects();

	/*bool TestCollision(GameObject const*const,GameObject const*const);*/

	std::list<Entity*> _objects;
	std::list<GameObject*> _gameObjects;
	std::vector<Entity*> _toRemove;

	Window *const _window;
	Render *const _render;

	Keyboard const*const _keyboard;
	Keyboard* _lastState;
};
#endif
