#ifndef GRAPHICS_H
#define GRAPHICS_H

enum GFX
{
	GFX_BIT,
	GFX_GWB,
	GFX_MAP,
	GFX_UNICORN,
	GFX_MAX
};

enum Font
{
	FONT_ONE,
	FONT_MAX
};

class Graphics
{
public:
	static bool LoadGraphics();
	static void UnloadGraphics();
	static Texture const* GetChar(int font,char);
	static Texture const* GetTexture(GFX);
private:
	static SDL_Surface *GenerateCharacter(char c,TTF_Font *const);
	static SDL_Surface *LoadImage(std::string file);
	static bool LoadTTFFont(std::string file);
	static void LoadFontTextures(Font font,TTF_Font *const);
	static Texture *CreateTexture(SDL_Surface*, int frames = 1);
	static inline int NextPowerOfTwo(int);

	static std::map<GFX,Texture*> _gfx;
	static Texture* _fonts[FONT_MAX][128];
	static bool _loaded;
};
#endif
