#include <iostream>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <string>
#include <map>
#include <vector>
#include "Texture.h"
#include "Transform.h"
#include "Colour.h"
#include "Vector.h"
#include "Rectangle.h"
#include "Graphics.h"
#include "Entity.h"
#include "GameObject.h"
#include "GravityWell.h"

GravityWell::GravityWell(GameObject* source):GameObject(Vector()),_source(source)
{
	_t = Graphics::GetTexture(GFX_BLACKHOLE);

	_radius = sqrt(6.67*pow(10,-11)*source->GetMass()/0.1);

	_tr->scale = _radius/150.0f;
	_hitbox = new Rectangle(_radius*2,_radius*2);

	std::cout << _tr->scale.x << std::endl;
	_colour.r = 0.3;
	_colour.a = 0.0;

	_width = 2*_radius;
	_height = _width;

	_tr->pos = source->GetCentre();

	_collides = true;
}

void GravityWell::Update()
{
}

void GravityWell::IsInside(GameObject* g,Vector const& uRel, Vector const& dif)
{
	Vector centre = g->GetCentre();
	if(GetDistanceTo(centre) <= _radius)
	{
		if(GetDistanceTo(centre) >= 150)
		{
			Vector dif = GetCentre() - g->GetCentre();
			float m = g->GetMass();
			float M = _source->GetMass();
			float d = dif.Magnitude();
			Vector dir = dif.Versor();

			Vector f = F_Grav(m,M,d,dir);

			g->AddForce(f);
		}
	}
}

float GravityWell::GetRadius() const { return _radius; }	
