#include "Keyboard.h"

Keyboard::Keyboard()
{
	for(int i = 0; i < NKEYS; i++)
		_keys[i] = false;
}

Keyboard::Keyboard(const Keyboard& keyboard)
{
	*this = keyboard;
}
bool Keyboard::Shift() const
{
	return _keys[303] | _keys[304];
}

bool Keyboard::Ctrl() const
{
	return _keys[305] | _keys[306];
}

bool Keyboard::Alt() const
{
	return _keys[307] | _keys[308];
}

bool Keyboard::IsPressed(char c) const
{
	return _keys[c];
}

bool Keyboard::IsReleased(char c) const
{
	return !_keys[c];
}

void Keyboard::KeyPress(int k)
{
	if(k < NKEYS)
	{
		_keys[k] = true;
	}
}

void Keyboard::KeyRelease(int k)
{
	if(k < NKEYS)
	{
		_keys[k] = false;
	}
}
