#include <iostream>
#include <cmath>
#include <list>
#include <vector>
#include <deque>
#include <map>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>
#include "Transform.h"
#include "Texture.h"
#include "Vector.h"
#include "Rectangle.h"
#include "Colour.h"
#include "Timer.h"
#include "Audio.h"
#include "Window.h"
#include "Graphics.h"
#include "Entity.h"
#include "Render.h"
#include "GameObject.h"
#include "Keyboard.h"
#include "Letter.h"
#include "Text.h"
#include "FPSText.h"
#include "GameState.h"
#include "Game.h"

Letter::Letter(Vector pos, char c,Font font, int size, Text const* parent):Entity(pos)
{
	_t = Graphics::GetChar(font,c);

	_text = parent;

	_tr->scale = 0.01f;
	_tr->scale *= size;

	_colour.Set(0,0,0,1);
}

void Letter::Update()
{
	_colour = _text->GetColour();
}
