#ifndef LINE_H
#define LINE_H

struct Line
{
	Vector vertex1, vertex2;

	Line():vertex1(Vector()),vertex2(Vector()) {}
	Line(float x1, float y1, float x2, float y2)
		:vertex1(Vector(x1,y1)),vertex2(Vector(x2,y2)) {}
	Line(Vector const& v1, Vector const& v2):vertex1(v1),vertex2(v2) {}

	float dx() const
	{
		return vertex2.x - vertex1.x;
	}

	float dy() const
	{
		return vertex2.y - vertex1.y;
	}

	float Length() const
	{
		return sqrt(dx()*dx() + dy()*dy());
	}

	float dydx() const
	{
		return dy()/dx();
	}

	float dxdy() const
	{
		return dx()/dy();
	}

	Line operator+(Vector const& v)
	{
		return Line(vertex1 + v, vertex2 + v);
	}

	Line operator-(Vector const& v)
	{
		return Line(vertex1 - v, vertex2 - v);
	}

	Line const& operator+=(Vector const& v)
	{
		vertex1 += v;
		vertex2 += v;
		return *this;
	}

	Line const& operator-=(Vector const& v)
	{
		vertex1 -= v;
		vertex2 -= v;
		return *this;
	}
};
#endif
