#ifndef RECTANGLE_H
#define RECTANGLE_H
struct Rectangle
{
	Vector vertices[4];

	Rectangle() {}
	Rectangle(float w, float h)
	{
		/*vertices[ 0 ] = Vector( 0, 0 );
		vertices[ 1 ] = Vector( w, 0 );
		vertices[ 2 ] = Vector( w, h );
		vertices[ 3 ] = Vector( 0, h );*/
		vertices[ 0 ] = Vector( -w/2.f , -h/2.f );
		vertices[ 1 ] = Vector(  w/2.f , -h/2.f );
		vertices[ 2 ] = Vector(  w/2.f ,  h/2.f );
		vertices[ 3 ] = Vector( -w/2.f ,  h/2.f );
	}

	void Rotate(float angle)
	{
		Rotate(angle,Centre());
	}

	void Rotate(float angle,Vector p)
	{
		for(int i = 0; i < 4; ++i)
		{
			vertices[i].RotateAbout2D(angle,p);
		}
	}

	float Width() const
	{
		return sqrt(pow((vertices[ 1 ].x - vertices[ 0 ].x),2) +
			    pow((vertices[ 1 ].y - vertices[ 0 ].y),2));
	}

	float Height() const
	{
		return sqrt(pow((vertices[ 3 ].x - vertices[ 0 ].x),2) +
			    pow((vertices[ 3 ].y - vertices[ 0 ].y),2));
	}

	Vector Centre() const
	{
		return vertices[0] - (vertices[0] - vertices[2])/2;
	}
	

};
#endif
