#include <iostream>
#include <map>
#include <vector>
#include <list>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include "Transform.h"
#include "Texture.h"
#include "Vector.h"
#include "Rectangle.h"
#include "Colour.h"
#include "Window.h"
#include "Graphics.h"
#include "Entity.h"
#include "Render.h"
#include "GameObject.h"
#include "Bit.h"
#include "BitSocket.h"
#include "FrameStore.h"
#include "Frame.h"
#include "Keyboard.h"
#include "Timer.h"
#include "GameState.h"
#include "Game.h"

#include "Shell.h"

Shell::Shell(Vector const& pos):GameObject(pos)
{
	_frame = NULL;
}

Shell::~Shell()
{
	if(_frame != NULL)
	{
		Game::Remove(_frame);
	}
}

void Shell::Update()
{
	Steer();
	/*if(_frame != NULL)
	{
		*_tr = *_frame->GetTransform();
	}*/
}

void Shell::SetGroupID(Uint32 id)
{
	GameObject::SetGroupID(id);
	if(_frame != NULL)
	{
		_frame->SetGroupID(id);
	}
}

float Shell::GetWidth() const
{
	return _frame->GetWidth();
}

float Shell::GetHeight() const
{
	return _frame->GetHeight();
}

float Shell::GetRot() const
{
	return _frame->GetRot();
}

Vector const& Shell::GetVel() const
{
	return _frame->GetVel();
}

Vector const& Shell::GetPos() const
{
	return _frame->GetPos();
}

Vector Shell::GetCentre() const
{
	return _frame->GetCentre();
}
