#include <iostream>
#include <map>
#include <vector>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include "Transform.h"
#include "Texture.h"
#include "Vector.h"
#include "Rectangle.h"
#include "Colour.h"
#include "Window.h"
#include "Graphics.h"
#include "Entity.h"
#include "GameObject.h"

#include "Star.h"

unsigned int Star::_nStars = 0;

Star::Star(Vector const& pos, float brightness,float distance, Transform const*const cam):GameObject(pos),_cam(cam)
{
	_oldCam = *cam;
	_t = Graphics::GetTexture(GFX_STAR);
	_brightness = brightness;
	_distance = distance;
	_type = ENT_STAR;
	++_nStars;
}

Star::~Star()
{
	--_nStars;
}

void Star::Update()
{
	Vector dif = _cam->pos - _oldCam.pos;

	_tr->pos += dif*_distance;

	_oldCam = *_cam;
}

unsigned int Star::NumStars()
{
	return _nStars;
}
