#include "Timer.h"

Timer::Timer()
{
	_startTick = 0;
	
	_started = false;
	_paused = false;
}

void Timer::Start()
{
	_startTick = SDL_GetTicks();
	_started = true;
	_paused = false;
}

void Timer::Stop()
{
	_started = false;
	_paused = false;
}

void Timer::Pause()
{
	if(_started && !_paused)
	{
		_pausedTick = SDL_GetTicks();
		_paused = true;
	}
}

void Timer::Resume()
{
	_paused = false;
}

bool Timer::IsStarted()
{
	return _started;
}

bool Timer::IsPaused()
{
	return _paused;
}

Uint32 Timer::GetTicks()
{
	if(_paused)
	{
		return _pausedTick - _startTick;
	}
	if(_started)
	{
		return SDL_GetTicks() - _startTick;
	}

	return 0;
}
